<?php get_header(); ?>
<div id="gallery-wrap" class="container-fluid overflow-hidden art-gallery">
  <div id="gallery" class="carousel slide" data-bs-ride="carousel">
    <div class="leader pb-5">
      <div class="row mt-5">
        <div class="carousel-inner">
          <div class="carousel-item active gallery-image">
            <div class="d-flex justify-content-center">
              <img class="art-image" src="<?php echo get_template_directory_uri(); ?>/img/lemon-mater.jpg" alt="<?php the_title(); ?>"/>
            </div>
          </div>
          <?php query_posts('category_name=paintings&showposts=12'); ?>
          <?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
          <div class="carousel-item gallery-image">
            <div class="d-flex justify-content-center">
              <?php $img_url = wp_get_attachment_image_src(get_post_thumbnail_id(),'full'); ?>
              <img class="art-image img-fluid" src="<?php echo $img_url[0];?>" alt="<?php the_title(); ?>"/>
            </div>
          </div>
          <?php endwhile; ?>
        </div>
        <button class="carousel-control-prev" type="button" data-bs-target="#gallery" data-bs-slide="prev">
          <span class="carousel-control-prev-icon" aria-hidden="true"></span>
          <span class="visually-hidden">Previous</span>
        </button>
        <button class="carousel-control-next" type="button" data-bs-target="#gallery" data-bs-slide="next">
          <span class="carousel-control-next-icon" aria-hidden="true"></span>
          <span class="visually-hidden">Next</span>
        </button>
      </div>
    </div>
  </div>
</div>
<div class="container">
		<div class="row my-5">
			<h3><em>Art Projects</em></h3>
		</div>
    <div class="row">
    <div class="col-lg-3">
      <h4><a href="#figures">Figures</a></h4>
      <h4><a href="#landscapes">Landscapes</a></h4>
      <h4><a href="#still">Still Life</a></h4>
      <h4><a href="#abstract">Abstract</a></h4>
    </div>
    <div class="col-lg-9">
        <div class="row art-gallery py-3">
          <?php $i = 0; $query = new WP_Query(array('category_name' => 'paintings', 'posts_per_page' => -1));  while ( $query->have_posts() ) : $query->the_post(); ?>
            <div class="col-lg-4">
              <div class="studio-thumbnail">
                <?php
                  if (has_post_thumbnail()) {
                    $img_url = wp_get_attachment_image_src(get_post_thumbnail_id(), 'full');
                  } else {
                    $img_url = get_post_meta( get_the_ID(), 'featured_image_url');
                  }
                ?>
                <a href="<?php the_permalink(); ?>" title="<?php printf( esc_attr__( '%s', 'daw' ), the_title_attribute( 'echo=0' ) ); ?>" rel="bookmark"><img class="studio-thumb" src="<?php echo $img_url[0];?>" width="100%" alt="<?php the_title(); ?>"/></a>
              </div>
              <article class="studio">
                <div class="entry-content">
                  <h4><a href="<?php the_permalink(); ?>" title="<?php printf( esc_attr__( '%s', 'daw' ), the_title_attribute( 'echo=0' ) ); ?>" rel="bookmark"><?php the_title(); ?></a></h4>
                  <?php dw_good_excerpt(110); ?>
                </div>
              </article>
            </div>
          <?php if((++$i % 3) == 0): ?>
        </div>
        <div class="row art-gallery">
          <?php endif; ?>
          <?php endwhile; $i++;?>
        </div>
      </div>
    </div>
  </div>
</div>
<?php get_footer(); ?>
