<?php
/*
Template Name: Desk
*/

get_header(); ?>
<?php get_template_part( 'underscore' ); ?>
	<div class="container leader">
		<div class="row">
			<div class="col-md-12">
				<h1 id="desk" class="cm-sans wow fadeInLeft">Desk</h1>
			</div>
		</div>
		<div class="row desk pt-5">
			<div class="col-md-5">
				<div class="entry-content">
					<h4 class="georgia spread"><em><span class="firstcharacter">T</span>he internet is ok if you look in the right places. It's also awash with nonsense</em>. I'm just hoping not to contribute to the nonsense. I publish little essays, notes, ideas, images, or pretty much anything else I want to share here. This site started with mostly computer related ramblings, but I went elsewhere with it after I quit the social networks. I wrote a <a href="/my-personal-website/">post about this website</a>. The easiest way to quickly scan everything on it is through the <a href="/archive/">archive</a> or <a href="/sitemap/">sitemap</a> pages.
            <br /><br />Feel free to <a href="/contact/">contact me</a> if you have any feedback, questions, or just want to say hello. <br /><br />Thanks for the visit,</h4>
					<img src="<?php echo get_template_directory_uri() . '/img/dw_signature.png'; ?>" alt="David Windham Signature"/>
					<img src="<?php echo get_template_directory_uri() . '/img/desk.png'; ?>" alt="Who Needs a Computer Anyway?" width="90%" style="margin:50px 10px 20px;border:3px solid #cecece"/>
				</div>
				<div class="studio-tools d-none d-lg-block">
						<ul>
							<li><u>Recent Bookmarks</u></li>
							<?php bookmarks_pull(); ?>
						</ul>
					</div>
			</div>
			<div class="col-md-4 studio-tools">
				<ul>
          <?php $sticky = get_option('sticky_posts');?>
          <?php if( !empty($sticky) ){ ?>
          <?php $args = array('post_type' => 'post','posts_per_page' => 5,'post__in' => $sticky);?>
					<?php $stickyposts = get_posts($args); ?>
            <li>Recently Edited</li>
            <?php foreach ($stickyposts as $post) : setup_postdata($post); ?>
              <li style="color:#777"><?php echo get_the_date('m/d/y'); ?> - <a href="<?php the_permalink() ?>"><?php the_title(); ?></a></li>
					  <?php endforeach; ?>
          <br>
          <?php } ?>
					<li><u>Recent Posts</u></li>
					<?php $recentposts = get_posts('numberposts=68'); foreach ($recentposts as $post) : setup_postdata($post); ?>
					       <li style="color:#777"><?php echo get_the_date('m/d/y'); ?> - <a href="<?php the_permalink() ?>"><?php the_title(); ?></a></li>
					<?php endforeach; ?>
				</ul>
			</div>
			<div class="col-lg-3">
				<div class="row"style="padding:20px 0 0 0;">
					<?php get_search_form(); ?>
				</div>
				<div class="row">
				<div class="col-sm-6 studio-tools">
						<ul>
							<li>Year</li>
							<?php wp_get_archives( array( 'type' => 'yearly') ); ?>
						</ul>
					</div>
					<div class="col-sm-6 studio-tools">
						<ul>
							<?php wp_list_categories('orderby=name&exclude=1,7,44&title_li=Topics'); ?>
						</ul>
					</div>
				</div>
				<div class="row">

						<ul class="tags">
							<li><u>Tags</u></li>
							<?php $tags = get_tags(); if ( $tags ) : foreach ( $tags as $tag ) : ?>
							<a href="<?php echo esc_url( get_tag_link( $tag->term_id ) ); ?>" title="<?php echo esc_attr( $tag->name ); ?>"><?php echo esc_html( $tag->name ); ?></a>,
							<?php endforeach; endif; ?>
						</ul>

				</div>
				<div class="row">
					<div class="col-md-12 studio-tools">
						<h5><u>Today I Learned</u></h5>
						<ul>
							<?php pull_til(); ?>
						</ul>
					</div>
				</div>
			</div>
      <div class="float-end mt-n3">
			  <a href="/archive/" type="button" class="btn btn-dark float-end">View Archives</a>
		  </div>
		</div>
	</div>
	<div class="container">
		<div id="content" role="main">
			<main id="main" class="site-main" role="main">
			<?php query_posts('showposts=10'); ?>
			<?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
			<article id="content" class="single" role="main">
				<div itemscope="" itemtype="http://schema.org/BlogPosting" id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
					<div class="entry-content">
						<div class="date">
							<time class="updated" datetime="<?php the_time('c');?>" itemprop="datePublished"><?php the_date('n/j/Y'); ?></time>
						</div>
						<span class="author vcard"><span class="fn">David A. Windham</span></span>
						<h2 class="entry-title"><a href="<?php the_permalink(); ?>" title="<?php printf( esc_attr__( '%s', 'daw' ), the_title_attribute( 'echo=0' ) ); ?>" rel="bookmark"><?php the_title(); ?></a></h2>
						<?php the_content(); ?>
						<div class="clear">&nbsp;</div>
					</div>
				</div>
			</article>
			<?php endwhile; ?>
			</main>
		</div>
	</div>
<?php get_footer('home'); ?>
